local num = nil
local _ = nil
local created = false

local dungeonMap = { --/run print(C_ChallengeMode.GetMapUIInfo(C_MythicPlus.GetOwnedKeystoneChallengeMapID()))
	[375] = "MoTS", -- Mists of Tirna Scithe
	[376] = "NW", -- Necrotic Wake
	[377] = "DOS", -- De Other Side
	[378] = "HoA", -- Halls of Atonement
	[379] = "PF", -- Plaguefall
	[380] = "SD", -- Sanguine Depths
	[381] = "SoA", -- Spires of Ascension
	[382] = "ToP", -- Theater of Pain
	[391] = "Strt", --Tazavesh: Streets of Wonder
	[392] = "Gmbt" --Tazavesh: So'leah's Gambit
}

local MYAFrame = CreateFrame('Frame', 'MayceiaAltsFrame', UIParent)
MYAFrame:SetFrameStrata('Background')
MYAFrame:EnableMouse(true)
MYAFrame:SetMovable(true)
MYAFrame:RegisterForDrag('LeftButton')
MYAFrame:SetScript('OnDragStart', function(self) self:StartMoving() end)
MYAFrame:SetScript('OnDragStop', function(self) self:StopMovingOrSizing() end)
MYAFrame:SetPoint('CENTER', 0, 0)
MYAFrame:SetClampedToScreen(true)
MYAFrameTexture = MYAFrame:CreateTexture(nil, 'Background')
MYAFrameTexture:ClearAllPoints()
MYAFrameTexture:SetColorTexture(25/255, 25/255, 25/255, 0.80)
MYAFrameTexture:SetAllPoints(MYAFrame)
MYAFrame:Hide()

MYAFrame:RegisterEvent('PLAYER_LOGIN')
MYAFrame:RegisterEvent('UNIT_INVENTORY_CHANGED')
MYAFrame:SetScript('OnEvent', function(self, event, arg1, ...)
	--if event == 'ADDON_LOADED' and arg1 == 'MayceiaAlts' then
	if event == 'PLAYER_LOGIN' then
		MYA_DB = MYA_DB or {}
		if MYA_DB.numAlts == nil then
			MYA_DB.numAlts = 0
			MYA_DB.weeklyReset = MYAFrame:GetNextWeeklyResetTime()
		end
		
		if MYA_DB.numAlts == 0 and UnitLevel('player') == 60 then
			MYA_DB.numAlts = 1
			num = 1
			MYA_DB[num] = {}
			MYA_DB[num].guid = UnitGUID('player')
		end
		
		if UnitLevel('player') == 60 then
			local testGuid = UnitGUID('player')
			for i = 1, MYA_DB.numAlts do 
				if MYA_DB[i].guid == testGuid then
					num = i
				end
			end
			if num == nil then
				MYA_DB.numAlts = MYA_DB.numAlts + 1
				num = MYA_DB.numAlts
				MYA_DB[num] = {}
				MYA_DB[num].guid = testGuid
			end
		end
		
		if MYA_DB.weeklyReset == nil then 
			MYA_DB.weeklyReset = MYAFrame:GetNextWeeklyResetTime() or nil
		end		
		local runs = C_MythicPlus.GetRunHistory(false, true)
	end
	
	if event == 'UNIT_INVENTORY_CHANGED' then
		MYAFrame:UpdateCharacter()
	end
	
	local currentTime = GetServerTime()
	if currentTime > MYA_DB.weeklyReset then
		MYAFrame:WeeklyReset()
	end
end)

SLASH_MYA1 = '/mya'
SlashCmdList['MYA'] = function(msg)
	if msg == 'hide' then 
		MYAFrame:Hide()
	elseif msg == 'purge' then
		MYA_DB = {}
		MYA_DB.numAlts = 0
		print('Mayceia Alts database purged,  relog to begin tracking new data')
	elseif msg == 'vault' then
		LoadAddOn("Blizzard_WeeklyRewards"); WeeklyRewardsFrame:Show()
	elseif msg == 'keyreset' then
		MYAFrame:WeeklyReset()
	else
		if not created then MYAFrame:CreateDataFrame() end
		MYAFrame:UpdateDataFrame()
		MYAFrame:Show()
	end
end 


function MYAFrame:UpdateCharacter()
	if UnitLevel('player') < 60 then return end
	MYA_DB[num].name = UnitName('player')
	_, MYA_DB[num].class = UnitClass('player')
	MYA_DB[num].faction = UnitFactionGroup('player')
	MYA_DB[num].ilvl = GetAverageItemLevel()
	MYA_DB[num].renown = C_CovenantSanctumUI.GetRenownLevel()
	MYA_DB[num].keyLevel = C_MythicPlus.GetOwnedKeystoneLevel()
	MYA_DB[num].keyMap = dungeonMap[C_MythicPlus.GetOwnedKeystoneChallengeMapID()]
	C_MythicPlus.RequestRewards()
	--MYA_DB[num].mPlus = C_MythicPlus.GetWeeklyChestRewardLevel()
	local runs = C_MythicPlus.GetRunHistory(false, true)
	local high = 0
	for i = 1, #runs do
		if runs[i].level > high then 
			MYA_DB[num].mPlus = runs[i].level 
			high = runs[i].level
		end
	end
	local animaTable = C_CurrencyInfo.GetCurrencyInfo(1813)
	MYA_DB[num].anima = animaTable.quantity
	local stygiaTable = C_CurrencyInfo.GetCurrencyInfo(1767)
	MYA_DB[num].stygia = stygiaTable.quantity
	local researchTable = C_CurrencyInfo.GetCurrencyInfo(1931)
	MYA_DB[num].research = researchTable.quantity
	local fluxTable = C_CurrencyInfo.GetCurrencyInfo(2009)
	MYA_DB[num].flux = fluxTable.quantity
	if C_QuestLog.IsQuestFlaggedCompleted(63854) then 
		MYA_DB[num].tormentors = 'Yes' 
	else 
		MYA_DB[num].tormentors = 'No' 
	end
end

MYA_Labels = {}
local numColumns = 10
function MYAFrame:CreateDataFrame()
	created = true
	local columnWidths = { --remember commas if you add to this
		[1] = 80, --name
		[2] = 50, --ilvl
		[3] = 54, --renown
		[4] = 60, --key
		[5] = 44, --mPlus
		[6] = 50, --anima
		[7] = 52, --stygia
		[8] = 54, --catalogued research
		[9] = 80, --tormentors
		[10] = 48 --cosmic flux
	}
	MYAFrame:SetHeight((25 * MYA_DB.numAlts) + 45)
	
	for i = 1, ((MYA_DB.numAlts + 1) * numColumns) do -- Create all text
		MYA_Labels[i] = MYAFrame:CreateFontString(nil, 'ARTWORK')
		MYA_Labels[i]:SetFont("Fonts\\ARIALN.ttf", 13)
	end
	
	for i = 1, MYA_DB.numAlts do
		local red, green, blue = GetClassColor(MYA_DB[i].class)
		local rowAnchor = -((i * 25) + 20)
		local columnSum = 0
	
		for j = 1, numColumns do
			local columnAnchor = (columnSum + (columnWidths[j] / 2))
			MYA_Labels[i * numColumns + j]:SetPoint('CENTER', MayceiaAltsFrame, 'TOPLEFT', columnAnchor, rowAnchor)
			MYA_Labels[i * numColumns + j]:SetTextColor(red, green, blue)
			columnSum = columnSum + columnWidths[j]
		end
		
		MYA_Labels[i * numColumns + 1]:SetText(MYA_DB[i].name)
		MYA_Labels[i * numColumns + 2]:SetText(math.floor(MYA_DB[i].ilvl))
		MYA_Labels[i * numColumns + 3]:SetText(MYA_DB[i].renown)
		if MYA_DB[i].keyLevel == nil then
			MYA_Labels[i * numColumns + 4]:SetText('?')
		else
			MYA_Labels[i * numColumns + 4]:SetText(MYA_DB[i].keyMap .. ' +' .. MYA_DB[i].keyLevel)
		end
		MYA_Labels[i * numColumns + 5]:SetText(MYA_DB[i].mPlus)
		MYA_Labels[i * numColumns + 6]:SetText(MYA_DB[i].anima)
		MYA_Labels[i * numColumns + 7]:SetText(MYA_DB[i].stygia)
		MYA_Labels[i * numColumns + 8]:SetText(MYA_DB[i].research)
		MYA_Labels[i * numColumns + 9]:SetText(MYA_DB[i].tormentors)
		MYA_Labels[i * numColumns + 10]:SetText(MYA_DB[i].flux)
	end
	
	local columnSum = 0
	for i = 1, numColumns do
		local columnAnchor = (columnSum + (columnWidths[i] / 2))
		MYA_Labels[i]:SetPoint('CENTER', MayceiaAltsFrame, 'TOPLEFT', columnAnchor, -20)
		MYA_Labels[i]:SetTextColor(204, 153, 0)
		columnSum = columnSum + columnWidths[i]
	end
	
	MYAFrame:SetWidth(columnSum + 30)
	MYA_Labels[1]:SetText('Name')
	MYA_Labels[2]:SetText('ilvl')
	MYA_Labels[3]:SetText('Renown')
	MYA_Labels[4]:SetText('Key')
	MYA_Labels[5]:SetText('M+')
	MYA_Labels[6]:SetText('Anima')
	MYA_Labels[7]:SetText('Stygia')
	MYA_Labels[8]:SetText('Research')
	MYA_Labels[9]:SetText('Tormentors')
	MYA_Labels[10]:SetText('Flux')
	
	MYA_CloseButton = CreateFrame('Button', 'MYA_CloseBtn', MYAFrame, 'UIPanelCloseButton')
	MYA_CloseButton:ClearAllPoints()
	MYA_CloseButton:SetPoint('TOPRIGHT', MYAFrame, 'TOPRIGHT', 0, 0)
	MYA_CloseButton:SetScript("OnClick", function() MYAFrame:Hide() end)
end

function MYAFrame:UpdateDataFrame()
	if UnitLevel('player') < 60 then return end
	MYAFrame:UpdateCharacter()
	
	MYA_Labels[num * numColumns + 1]:SetText(MYA_DB[num].name)
	MYA_Labels[num * numColumns + 2]:SetText(math.floor(MYA_DB[num].ilvl))
	MYA_Labels[num * numColumns + 3]:SetText(MYA_DB[num].renown)
	if MYA_DB[num].keyLevel == nil then
		MYA_Labels[num * numColumns + 4]:SetText('?')
	else
		MYA_Labels[num * numColumns + 4]:SetText(MYA_DB[num].keyMap .. ' +' .. MYA_DB[num].keyLevel)
	end
	MYA_Labels[num * numColumns + 5]:SetText(MYA_DB[num].mPlus)
	MYA_Labels[num * numColumns + 6]:SetText(MYA_DB[num].anima)
	MYA_Labels[num * numColumns + 7]:SetText(MYA_DB[num].stygia)
	MYA_Labels[num * numColumns + 8]:SetText(MYA_DB[num].research)
	MYA_Labels[num * numColumns + 9]:SetText(MYA_DB[num].tormentors)
	MYA_Labels[num * numColumns + 10]:SetText(MYA_DB[num].flux)
end

function MYAFrame:WeeklyReset()
	for i = 1, MYA_DB.numAlts do 
		MYA_DB[i].keyLevel = nil
		MYA_DB[i].keyMap = nil
		MYA_DB[i].mPlus = 0
		MYA_DB[1].tormentors = false
	end
	
	MYA_DB.weeklyReset = MYAFrame:GetNextWeeklyResetTime()
end

function MYAFrame:GetNextWeeklyResetTime()
	local resetDay = nil
	if (GetCurrentRegion() == 1) then resetDay = 3 end
	if (GetCurrentRegion() == 3) then resetDay = 4 end
	local d = C_DateAndTime.GetCurrentCalendarTime()
	local weekReset = GetServerTime() + GetQuestResetTime()
	local resetHour = d.hour + ceil(GetQuestResetTime()/3600)
	resetHour = resetHour % 24
	local daysLeft = 7 - (d.weekday - resetDay)
	if (d.hour < resetHour) then daysLeft = daysLeft + 1 end
	if daysLeft > 7 then daysLeft = daysLeft - 7 end
	for i = 2, daysLeft do
		weekReset = weekReset + 86400
	end
	return weekReset
end

